/*
This file is part of Noob-a-Tron.

Copyright Jeff Mitchell 2016

Noob-a-Tron is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Noob-a-Tron is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Noob-a-Tron.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef GRAPHICS_H_INCLUDED
#define GRAPHICS_H_INCLUDED
#include "graphics.h"
#endif

Graphics::Graphics() {
Window = SDL_CreateWindow("test", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, 800, 600, SDL_WINDOW_SHOWN);
backbuffer = SDL_GetWindowSurface(Window);
colour = SDL_MapRGB(backbuffer->format, 40, 0, 255 );
}

void Graphics::init() {

plasticBMP = SDL_LoadBMP("plastic.bmp");
specialopsBMP = SDL_LoadBMP("soldier.bmp");
RemoveMask(plasticBMP);
RemoveMask(specialopsBMP);
}

void Graphics::RemoveMask(SDL_Surface* Image) {
Uint32 ColourKey = SDL_MapRGB(Image->format, 255, 0, 255);
SDL_SetColorKey(Image, SDL_TRUE, ColourKey);
}

void Graphics::stop() {
SDL_FreeSurface(plasticBMP);
SDL_FreeSurface(specialopsBMP);
SDL_FreeSurface(backbuffer);
SDL_DestroyWindow(Window);
}

void Graphics::kleenScreen() {
SDL_FillRect(backbuffer, NULL, colour);
}

void Graphics::flip() {
SDL_UpdateWindowSurface(Window);
}
